#include <stdio.h>
#include "module.h"
#include <stdlib.h>

void sukurti (struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{ 
    struct dvipElem *elem;
    int x, k, i;
    *pradzia = NULL;
    *pabaiga = NULL;
    printf ("Ivesk kiek bus elementu saraše: \n");
    char term;
    if(scanf("%d%c", &k, &term) != 2 || term != '\n')
    {
        printf("Ivestas netinkamas simbolis.\n");
        return;
    }
    
    for (i = 0; i < k; i++)
    {
        printf ("Ivesk sveika skaiciu: \n");
        if(scanf("%d%c", &x, &term) != 2 || term != '\n')
        {
            printf("Ivestas netinkamas simbolis.\n");
            return;
        }
        if (*pradzia == NULL)
        {
            elem = (struct dvipElem*) malloc (sizeof (struct dvipElem) );
            elem->duom = x;
            elem->priekin = NULL;
            elem->atgal = NULL;
            *pradzia = elem;
            *pabaiga = elem;
        }
        else
        {
            elem = (struct dvipElem*) malloc (sizeof (struct dvipElem) );
            elem->duom = x;
            (*pabaiga)->priekin = elem;
            elem->atgal = *pabaiga;
            elem->priekin = NULL;
            *pabaiga = elem;
        }
    }
    printf ("Sarasas sukurtas!\n");
}

void spausdinti (struct dvipElem* *pradzia)
{
    struct dvipElem *elem;
    elem = *pradzia;
    if(elem == NULL)
    {
        printf("Pirma sukurk sarasa.\n");
        return;
    }
    printf ("Ivesti elementai:\n");
    while(elem!=NULL)  
    {
         printf("-> %d ",elem->duom);
         elem=elem->priekin;
    }
    printf ("\n");
}

void iterpti (struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{
    struct dvipElem *elem, *elemk;
    int i, pos, x;
    char term;

    printf ("Ivesk sveika skaiciu, kuri nori iterpti i sarasa:\n");
    if(scanf("%d%c", &x, &term) != 2 || term != '\n')
    {
        printf("Ivestas netinkamas simbolis.\n");
        return;
    }  
    printf ("Ivesk pozicija kur nori iterpti:\n");
    if(scanf("%d%c", &pos, &term) != 2 || term != '\n')
    {
        printf("Ivestas netinkamas simbolis.\n");
        return;
    }      
    
    if ((*pradzia== NULL) && (pos != 1))
    {
        printf("\nSarasas yra tuscias, galima iterpti tik i pirma pozicija.\n");
        return;
    }

    if ((elem == NULL) && (pos == 1))
    {
        elem = (struct dvipElem*) malloc (sizeof (struct dvipElem));
        elem->duom = x;
        elem->priekin = *pradzia;
        elem->atgal = NULL;
        *pradzia = elem;
        return;
    }
    elemk = *pradzia;

    for ( i = 1; i < pos; i++)
    {
        elemk = elemk->priekin;
	if (elemk == NULL)
        {
            printf ("Tokia pozicija neegzistuoja\n");
            return;
        }
    }

    elem = (struct dvipElem*) malloc (sizeof (struct dvipElem));
    elem->duom = x;
    elemk->atgal->priekin = elem;
    elem->atgal = elemk->atgal;
    elem->priekin = elemk;
    elemk->atgal = elem;

    printf ("\n");
}

void iterpti_pab(struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{
    int value;
    char term;
    printf ("Ivesk skaiciu kuri nori iterpti: \n");
    if(scanf("%d%c", &value, &term) != 2 || term != '\n')
    {
        printf("Ivestas netinkamas simbolis.\n");
        return;
    }
    
    struct dvipElem *elem, *elemk;
    elem = (struct dvipElem *)malloc(sizeof(struct dvipElem));
    elem->duom = value;
    if(*pradzia==NULL)
    {
         *pradzia=elem;
         elem->atgal=NULL;
         elem->priekin=NULL;
         *pabaiga = *pradzia;
    }
    else
    {
        *pabaiga = *pradzia;
        while(*pabaiga!=NULL)
        {
            elemk = *pabaiga;
            *pabaiga = elemk->priekin;
        }
        *pabaiga=elem;
        elemk->priekin=*pabaiga;
        elem->atgal=elemk;
        elem->priekin=NULL;
    }
    return;
}

void naikinti (struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{
    struct dvipElem *elem;
    if ((*pradzia != NULL) && (*pabaiga != NULL))
    {
        while (*pradzia != NULL)
        {
            elem = *pradzia;
            *pradzia = elem->priekin;
            elem->atgal = NULL;
            free(elem);
        }
        printf ("Sarasas sunaikintas\n");
    }
    else 
    {
        printf ("Sarasas tuscias\n");
        return;
    }
}

void trinti_gale(struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{
      struct dvipElem *temp;
      temp = *pabaiga;
      if(temp->atgal==NULL)
      {
           free(temp);
           *pradzia=NULL;
           *pabaiga=NULL;
           return;
      }
      *pabaiga = temp->atgal;
      temp->priekin = NULL;
      free(temp);
      return;
} 


void trinti_vidury(struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{  
    struct dvipElem *elem, *elemk, *temp;
    elem = *pradzia;
    int value;
    char term;
    
    if(elem == NULL)
    {
        printf("Pirma sukurk sarasa.\n");
        return;
    }
    
    printf ("Iveskite koki skaiciu norite istrinti: \n");
    if(scanf("%d%c", &value, &term) != 2 || term != '\n')
    {
        printf("Ivestas netinkamas simbolis.\n");
        return;
    }      
    while(elem!=NULL)
    {
        if(elem->duom == value)
        {
             if(elem->atgal == NULL)
             {
                  free(elem);
                  pradzia = NULL;
                  pabaiga = NULL;
                  return;
             }
             else
             {
                  elemk->priekin = temp;
                  temp->atgal = elemk;
                  free(elem);
                  return;
             }
        }
        else
        {
            elemk = elem;
            elem = elem->priekin;
            temp = elem->priekin;
        }
    }
}

